﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;

namespace deFramework.Common
{
    /// <summary>
    /// All SIAC application constants should go here rather than being hard-coded anywhere else. 
    /// Some could be parameterized as configurable site properties, web part properties, etc. 
    /// </summary>
    /// <remarks>A good practice in software development is to have configurable parameters. However this can be overdone. 
    /// Nevertheless its always important to prepare for such possibilities. Thus the first step is to "get the code working" 
    /// by hard-coding wherever is needed. Then move these hard-coded values to be references to constants here. 
    /// Next organize the constants in order to anticipate and be ready for supporting configurable parameters.</remarks>
    public class FrameworkConstants
    {
        /// <summary>
        /// 
        /// </summary>
        public static string kSingleTextWhereCamlTemplate = "<Where><Eq><FieldRef Name='{0}' /><Value Type='Text'>{1}</Value></Eq></Where>";
        
        /// <summary>
        /// 
        /// </summary>
        public static int kResultsPageSize = 20;
        //todo: organize constants 

        //public static string kFilterTypeNone = "none";
        //public static string kFilterTypeTitle = "title";
        //public static string kFilterTypeAll = "all"; 

        //public static string kParamName_SiteProperty_StoreCategories = "SolutionStoreCategories";
        //public static string kDefaultValue_StoreCategories = "Basic, Intermediate, Advanced, Expert, A1, A2, A3, A4, A5, A6, A7, A8, A9, A10"; 

        //public static string kParamConstructingContainerID = "ParamConstructingContainerID";
        //public static string kSolutionStoreListName = "SolutionStore";
        //public static string kSolutionFeedbackListName = "SolutionFeedback";

        //public static string kDefaultSolutionDetailsSourceParamName = "contexturl";

        //public static string kFieldName_Title = "Title"; 
        //public static string kFieldName_Description = "Description";
        //public static string kFieldName_Narrative = "Narrative";
        //public static string kFieldName_Group = "Group";
        //public static string kFieldName_ConfigurationUrl = "ConfigurationUrl";
        //public static string kFieldName_IconUrl = "IconUrl";
        //public static string kFieldName_ImageUrl = "ImageUrl";
        //public static string kFieldName_DocumentationUrl = "DocumentationUrl";
        //public static string kFieldName_State = "State";
        //public static string kFieldName_Categories = "Categories";
        //public static string kFieldName_ID = "ID";
        //public static string kFieldName_PartIdInGallery = "IdGallery";
        ////public static string kFieldName_SolutionStoreItemId = "IdStore"; 

		
        //public static string kDefaultLabel_SolutionDocumentationMissing = "Documentation N/A";
        //public static string kDefaultLabel_SolutionDocumentationLink = "More Documentation";
        //public static string kDefaultLabel_SolutionTitleText = "[Solution Title goes here]";
        //public static string kDefaultLabel_SolutionGroup = "n/a";
        //public static string kDefaultLabel_Categories = "n/a"; 

        //public static string kDefaultHtml_SolutionDescriptionHtml = "[<B>Solution Description </B>&nbsp;&nbsp;<I> goes here</I>]";

        //public static string kDefaultRelativeUrl_SolutionIcon = "/_layouts/images/allcontents.png";
        //public static string kDefaultRelativeUrl_SolutionImage = "/_layouts/images/AccSolutionStore/moss_image.png";
        //public static string kDefaultRelativeUrl_SolutionDocumentation = "/_layouts/AccSolutionStore/DemoDocumentation.aspx";
        //public static string kDefaultRelativeUrl_SolutionDetails = "/_layouts/AccSolutionStore/SolutionDetails.aspx";
        //public static string kDefaultRelativeUrl_SolutionAdd = "/_layouts/AccSolutionStore/SolutionAdd.aspx";

        //public static string kDefaultParamName_DisplayHeading = "DisplayHeading";


    }
}


#region "Dead Code" 

//public static string kSolutionStoreSiteUrl = "http://localhost";
//public static string kDefaultSolutionImageUrl = "/_layouts/images/allcontents.png";
//public static string kDefaultSolutionTitleText = "[Solution Title goes here]";
//public static string kDefaultSolutionDescriptionHtml = "[<B>Solution Description </B>&nbsp;&nbsp;<I> goes here</I>]";
//public static string kDefaultSolutionGroup = "n/a";
//public static string kContainerPropertyValueStringFormat = "{0}prop{1}";
        

#endregion 